/*
 * Main entry points of the BIOS emulation library.
 */

#include "bios.h"
#include "../psx/interpreter.h"
#include "../psx/msg.h"
#include "table.h"

void psx_bios_entry(uint8_t which, uint32_t* GPR)
{
    uint16_t call = (GPR[T1] & 0xFFFF);

    if (psx_bios_table[which][call])
        psx_bios_table[which][call](GPR);
    else
        psx_fail("unhandled BIOS call %X:%02X\n", which + 0xA, call);
}
