/*
 * Contains the table of all the BIOS syscalls.
 */

#include "pad.h"
#include "printf.h"
#include "strlen.h"
#include "table.h"

#include <stdlib.h>

#define ENTRY(id, func) [id] = psx_bios_##func,

bios_func psx_bios_table[3][0xFF] =
{
    /* AO */
    {
        ENTRY(0x1B, strlen)
        ENTRY(0x3F, printf)
    },

    /* B0 */
    {
        ENTRY(0x14, pad_stop)
        ENTRY(0x15, pad_init)
    },

    /* C0 */
    {
        NULL
    }
};
