(*
 * Operations on bits of an OCaml int32.
 *)

(*
 * Bits.get n x y returns bits x .. y of n, counted as below :
 *
 * 31 30 29 28 27 26 25 24 23 22 ... 8  7  6  5  4  3  2  1  0
 * MSB                                                     LSB
 *)
external get : int32 -> int -> int -> int = "bits_get" "noalloc"

(*
 * Bits.switch_endian transforms a LE number into a BE number and
 * vice-versa.
 *)
external switch_endian : int32 -> int32 = "bits_switch_endian"
