(*
 * Implements the OS filesystem access functions.
 *
 * Uses a simple Pervasives.in_channel as the stream type.
 *)

module FS = Filesystem

type stream = Pervasives.in_channel

let stdin = Pervasives.stdin

let open_ = Pervasives.open_in

let close = Pervasives.close_in

let read chan n =
    let buf = String.create n in
    (buf, input chan buf 0 n)

let tell = Pervasives.pos_in

let rec seek chan = function
|   FS.Begin -> seek chan (FS.Absolute 0)
|   FS.Relative x -> seek chan (FS.Absolute ((tell chan) + x))
|   FS.End -> seek chan (FS.Absolute (in_channel_length chan))
|   FS.Absolute x -> seek_in chan x

let eof chan =
    (tell chan) = (in_channel_length chan)
