#!/bin/sh
#
# Generates a ML and a C configuration file.

CFG=Makefile.config
test -e Makefile.config.local && CFG="$CFG Makefile.config.local"

getlast() {
    tail -n 1
}

getvar() {
    grep -h "^$1=" $CFG \
        | cut -d '=' -f 2- \
        | getlast
}

llvmexe_helper() {
    p=`llvm-config --bindir`
    [ -x "$p/$1" ] && echo "$p/$1"
    [ -x "$p/$1.exe" ] && echo "$p/$1.exe"
}

llvmexe() {
    llvmexe_helper $1 | getlast
}

sysexe() {
    which `getvar $1`
}

ccfg() {
cat << EOT
#ifndef PREFIX
# define PREFIX "`getvar PREFIX`"
#endif

#ifndef LIBDIR
# define LIBDIR "`getvar PREFIX`/lib"
#endif

#ifndef LLVM_PREFIX
# define LLVM_PREFIX "`llvm-config --prefix`"
#endif

#ifndef LLC_PATH
# define LLC_PATH "`llvmexe llc`"
#endif

#ifndef CC_PATH
# define CC_PATH "`sysexe CC`"
#endif
EOT
}

ccfg > config.h
