/*
 * Handles address adaptations.
 */

#ifndef __PSX_ADDRESS_H_
# define __PSX_ADDRESS_H_

# include "globals.h"

# include <stdint.h>

static inline uint32_t adapt_j_address(uint32_t) __attribute__((pure));
static inline uint32_t adapt_branch_address(uint32_t) __attribute__((pure));
static inline uint32_t adapt_pc_to_off(uint32_t) __attribute__((pure));

/* Adapt addresses contained in the instructions */
static inline uint32_t adapt_j_address(uint32_t instr_addr)
{
    return (t_seg_addr & 0xF0000000) + (instr_addr << 2);
}

static inline uint32_t adapt_branch_address(uint32_t instr_addr)
{
    return pc + ((int16_t)instr_addr) * 4;
}

/* Adapt PC value */
static inline uint32_t adapt_pc_to_off(uint32_t pc)
{
    return (pc - t_seg_addr) >> 2;
}

#endif
