/*
 * CPU/GPU plugin communication.
 */

#ifndef __PSX_GPU_H_
# define __PSX_GPU_H_

# include <stdint.h>

extern int (*psx_gpu_init)(void);
extern int (*psx_gpu_open)(unsigned long*, const char*, const char*);
extern int (*psx_gpu_close)(void);
extern int (*psx_gpu_shutdown)(void);
extern uint32_t (*psx_gpu_read_data)(void);
extern void (*psx_gpu_read_data_mem)(uint32_t*, int);
extern uint32_t (*psx_gpu_read_status)(void);
extern void (*psx_gpu_write_data)(uint32_t);
extern void (*psx_gpu_write_data_mem)(uint32_t*, int);
extern void (*psx_gpu_write_status)(uint32_t);
extern void (*psx_gpu_dma_chain)(uint32_t*, uint32_t);

void psx_gpu_load(void);
void psx_gpu_unload(void);

unsigned long* psx_gpu_get_display(void);

void psx_gpu_do_dma(uint32_t madr, uint32_t bcr, uint32_t chcr);

#endif
