/*
 * Handles hardware mapped registers access.
 * 
 * Approximately the same API as the memory access module.
 */

#ifndef __PSX_HARDWARE_H_
# define __PSX_HARDWARE_H_

# include <stdint.h>

/* Set by main.c, depending on the command line arguments */
extern int log_unhandled_hw;

uint8_t psx_hardware_read_8(uint16_t addr);
uint16_t psx_hardware_read_16(uint16_t addr);
uint32_t psx_hardware_read_32(uint16_t addr);

void psx_hardware_write_8(uint16_t addr, uint8_t data);
void psx_hardware_write_16(uint16_t addr, uint16_t data);
void psx_hardware_write_32(uint16_t addr, uint32_t data);

#endif
