/*
 * Defines the functions used to emulate the R3000 instructions.
 */

#ifndef __PSX_INSTRS_H_
# define __PSX_INSTRS_H_

# include <stdint.h>

/* See disasm/r3000_reg.ml */
enum
{
    R0 = 0,
    AT,
    V0, V1,
    A0, A1, A2, A3,
    T0, T1, T2, T3, T4, T5, T6, T7,
    S0, S1, S2, S3, S4, S5, S6, S7,
    T8, T9,
    K0, K1,
    GP, SP, FP,
    RA
};

uint32_t psx_get_reg(int n);
void psx_set_reg(int n, uint32_t v);

void psx_exec_one(void);

/* Special instruction for BIOS handling */
void psx_instr_callbios(uint32_t, uint32_t, uint32_t, uint32_t);

#endif
