/*
 * Functions to provide info/error messages to the user.
 */

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

static void psx_real_message(FILE* stream, const char* format, va_list va)
{
    vfprintf(stream, format, va);
}

void psx_message(const char* format, ...)
{
    va_list va;

    va_start(va, format);
    psx_real_message(stdout, format, va);
    va_end(va);
}

void psx_fail(const char* format, ...)
{
    va_list va;

    va_start(va, format);
    psx_real_message(stderr, format, va);
    va_end(va);

    abort();
}
