// DEMO2.C (c) 2001 Blade
//
// Double-buffering
// Reading the pad
// Function: Print a message on the Playstation screen
//           Exit when L2 is pressed on the pad

// you always need this include
#include <bladeps.h>

// set up 2 OTs (one for each buffer), each 2000 bytes long
u_char ordering_table[2][2000];

u_long pad = 0;
u_long exit_flag = 0;

void main (void)
{
  // this will store the current buffer (0 or 1)
  int act;

  // initialise the pad
  PadInit ();

  // set up the screen size
  GsInitGraphQuick (320, 240);

  // loop while exit_flag = 0
  while (exit_flag == 0) {

    // get the current active buffer number (0 or 1)
    act = GsGetActiveBuff ();

    // point to the start of the current active OT
    GsSetWorkBase(&ordering_table[act][0]);

    // send a clear screen to the OT
    GsSortClear (50, 150, 50);

    // add some text to the OT
    FntPrint(0, 60, 90, "Hello World");
    FntPrint(0, 60, 110, "Press L2 to exit");

    // switch the buffers
    GsSwapDispBuff ();

    // draw the contents of the active OT
    GsDrawOT ((u_long *) &ordering_table[act][0]);

    // wait for Vertical Synchronisation
    WaitVSync();

    // read the pad
    pad = PadRead();

    // if L2 is pressed then flag to exit
    if ((pad & PAD_L2) > 0) exit_flag++;

  }

  // shut down the pad cleanly
  PadStop ();
}
