// DEMO3.C (c) 2001 Blade
//
// How to load and use a new font
// Access a TIM file (the font) as a .H include file
// Function: Print a message on the Playstation screen in two fonts
//           Toggle the font when CROSS and CIRCLE are pressed
//           Exit when L2 is pressed on the pad

// the all important include
#include <bladeps.h>

// include the new font
#include "rainbow.h"

u_char primitive_buffer[2][4000];

u_long pad = 0;
u_long exit_flag = 0;

void main (void)
{
  int act;
  int font_num = 0;

  PadInit ();

  GsInitGraphQuick (320, 240);

  // load the new one as font number '1'
  FntLoad (1, (TIMHEADER *)rainbow);

  while (exit_flag == 0) {

    act = GsGetActiveBuff ();

    GsSetWorkBase(&primitive_buffer[act][0]);

    GsSortClear (0, 0, 0);

    // print something in font 0 (the built-in font)
    FntPrint(0, 90, 70, "     Use");
    // print something in font 1 (the new font)
    FntPrint(1, 90, 90, "CROSS & CIRCLE");
    // print something in a font which is toggled
    FntPrint(font_num, 70, 110, "to toggle this line");

    FntPrint(0, 100, 160, "(L2 to exit)");

    GsSwapDispBuff ();

    GsDrawOT ((u_long *) &primitive_buffer[act][0]);

    WaitVSync();

    pad = PadRead();

    if ((pad & PAD_L2) > 0) exit_flag++;

    // do the font toggling
    if ((pad & PAD_CIRCLE) > 0)
      font_num = 1;

    if ((pad & PAD_CROSS) > 0)
      font_num = 0;

  }

  PadStop ();
}
